class CompteurMutex extends Compteur {

    private int val;
    private LockSemaphore<SemaphoreAtomicInteger> mutex;

    CompteurMutex(){ 
        val = 0;
        mutex = new LockSemaphore<>(new SemaphoreAtomicInteger());
    }

    void incr(){
        mutex.lock(); 
        try {
            val = val + 1;
        } finally {mutex.unlock();}
    }

    int get(){
        mutex.lock();
        try {
            int res = val;
            return res;      
        } finally { mutex.unlock();}
    }
}